/* arp.h */

/*
$Log: ARP.H,v $
Revision 4.0  2000/02/07 21:52:27  Administrator
rev 4.0

Revision 1.1.1.1  2000/01/23 21:03:27  Administrator
This is the initial release to be CVS'ed

 * Revision 2.0  91/11/30  18:56:13  ROOT_DOS
 * This now contains the conditional compile code to support MTOS on the
 * 68K. This divides the net into three tasks, one does the output, the next
 * the input from a serial port driver and the last is the interface to the
 * calling tasks. The code will also compile into the PC based system with
 * the #define MICROC included and it will run on the PC using port 1.
 *
*/

/* DARPA Internet Address Resolution Protocol */

#define AR_HRD 1		/* Ethernet hardware type code */
#define AR_PROT 0x0800		/* IP protocol address code */
#define AR_HLEN 6		/* Ethernet physical address length */
#define AR_PLEN 4		/* IP Protocol address length */
#define AR_TAB  6		/* size of IP-to-Ethernet address cache */
#define AR_TIME 5		/* time to wait for reply in secs */
#define AR_RTRY 2		/* num of times to try and ARP request */

/* Definitions of codes used in operation field of ARP packet */

#define AR_REQ 1		/* arp request to resolve address */
#define AR_RPLY 2		/* reply to resolve request */
#define AR_RREQ 3		/* reverse arp request (RARP packets ) */
#define AR_RRLY 4		/* reply to a reverse request */

struct arppak
{
	/* format of DARPA ARP packet */
	short ar_hrd;		/* type of hardware (Ethernet = 1) */
	short ar_prot;		/* format of proto. address (IP +0x0800) */
	char  ar_hlen;		/* hardware address length */
	char  ar_plen;		/* protocol address length */
	short ar_op;		/* arp operation (see list above) */
	Eaddr ar_sha;		/* senders physical hardware address */
	IPaddr ar_spa;		/* senders protocol address (ip addr) */
	Eaddr ar_tha;		/* targets physical address */
	IPaddr ar_tpa;		/* targets physical address */
};

/* Format of the IP-to-Ethernet address resolution cache */

struct arpent
{
	/* format of entry in ARP cache */
	char arp_state;		/* state of this entry (see below) */
	Eaddr arp_Ead;		/* Ethernet address of this host */
	IPaddr arp_Iad;		/* IP address of this host */
	int arp_dev;		/* Xinu device for this host route */
};

/* definitions of table entry states */
#define AR_FREE	'\0'		/* Entry is unused (initial value) */
#define AR_ALLOC '\1'		/* Entry is used but route is still unknown */
#define AR_RGATE '\2'		/* Entry is reachable only by gateway */
#define AR_RSLVD '\3'		/* Entry has been resolved with Eth. addr. */

struct arpblk
{
	/* all information about ARP cache */
	struct arpent arptab[AR_TAB];	/* ip to ethernet address cache */
	int atabsiz;		/* current entries in arptab */
	int atabnxt;		/* next position in arptab to use */
	int arpsem;		/* semaphore for access to ARP service */
	int arppid;		/* id of process waiting for arp reply */
	IPaddr arpwant;		/* IP addr process waiting for resolve */
	int rarppid;		/* id of process waiting for RARP reply */
	int rarpsem;		/* semaphore for access to RARP service */
};

extern struct arpblk Arp;

