/* deqna.h */

/* 
$Log: DEQNA.H,v $
Revision 4.0  2000/02/07 21:52:30  Administrator
rev 4.0

Revision 1.1.1.1  2000/01/23 21:03:28  Administrator
This is the initial release to be CVS'ed

 * Revision 2.0  91/11/30  18:56:20  ROOT_DOS
 * This now contains the conditional compile code to support MTOS on the
 * 68K. This divides the net into three tasks, one does the output, the next
 * the input from a serial port driver and the last is the interface to the
 * calling tasks. The code will also compile into the PC based system with
 * the #define MICROC included and it will run on the PC using port 1.
 *  
*/

/* Definitions Digital equipments Corporations DEQNA Ethernet interface */

/* Device register layout */
struct dqregs 
{
	/* deqna registers in I/O space */
	int d_addr;	/* when read low order byte of */
	int d_addr2;	/*  these and next 4 regs give */
			/*  6-byte Ethernet node address */
	char *d_rcmd;	/* list of read cmds in memory */
	char *d_rcmdh;	/* high order bits of d_rcmd */
	char *d_wcmd;	/* list of write cmds in memory */
	char *d_wcmdh;	/* high order bits of d_wcmd */
	char *d_vect;	/* interrupt vector */
	int d_csr;	/* control and status register */
};

/* Bits in the control and status registers */
#define DQ_ENBL		0000001	/* reciever enable */
#define DQ_REST		0000002	/* software reset */
#define DQ_NXMI		0000004	/* nonexistant memory interrupt */
#define DQ_BROM		0000010	/* fetch boot diag rom */
#define DQ_XLI		0000020	/* Xmit list invalid */
#define DQ_RLI		0000040	/* recieve list invalid */
#define DQ_IEN		0000100	/* interrupt enable */
#define DQ_XINT		0000200	/* xmit interrupt */
#define DQ_ILOP		0000400	/* internal loopback mode */
#define DQ_ELOP		0001000	/* external loopback mode */
#define DQ_TIME		0002000	/* sanity timer enable */
#define DQ_RES1		0004000	/* v}or reserved */
#define DQ_FUSE		0010000	/* fuse OK */
#define DQ_CARR		0020000	/* carrier present on ether */
#define DQ_RES2		0040000	/* v}or reserved */
#define DQ_RINT		0100000	/* recieve interrupt */

/* Command to device as it appears on buffer descriptor list in memory */

struct dcmd
{
	int dc_flag;	/* DEQNA command in memory */
	int dc_bufh;	/* flag word marked USED/UNUSED */
	char *dc_buf;	/* buffer addr. (low order bits) */
	int dc_len;	/* buffer length (see manual */
	int dc_st1;	/* status word 1 */
	int dc_st2;	/* status word 2 */
};

/* bits in the flag word of dcm */

#define DC_NUSED	0100000	/* this dcmd entry not in use */
#define DC_USED		0140000	/* DEQNA using this dcmd entry */

/* bits in the descriptor word of dcm (i.e. in dc_bufh) */

#define DC_VALID	0100000	/* this is a valid buffer address */
#define DC_CADDR	0040000	/* this is a chain address */
#define DC_ENDM		0020000	/* Xmit: } of message */
#define DC_SETUP	0010000	/* xmit: setup packet */
#define DC_NORM		0000000	/* Xmit: non-setup packet */
#define DC_ENDL		0000000	/* last descriptor in list */
#define DC_XRES		0007400	/* V}or reserved */
#define DC_LBIT		0000200	/* buffer }s on odd address */
#define DC_HBIT		0000100	/* buffer starts on odd address */

/* bits returned to first status word (dc_st1) */

#define DC_LUSE		0140000	/* LAST/USE bits (see manual) */
#define DC_INIT		0100000	/* Initial value of status word */
#define DC_ERRU		0040000	/* ERROR/USED bit (see manual) */
#define DC_LOSS		0010000	/* Xmit: lost carrier */
#define DC_NCAR		0004000	/* Xmit: no carrier */
#define DC_ST16		0002000	/* Xmit: timer enabled */
#define DC_ABRT		0001000	/* Xmit: abort */
#define DC_FAIL		0000400	/* Xmit: heartbeat failure */
#define DC_CCNT		0000200	/* Xmit: collision count */
#define DC_ESET		0020000	/* Recv: setup packet */
#define DC_DISC		0010000	/* Recv: discard packet */
#define DC_RUNT		0004000	/* Recv: runt packet (too short) */
#define DC_HLEN		0003400	/* Recv: bits 10:8 of rec. len. */
#define DC_LLEN		0000377	/* Recv: bits 7:0 of rec.len. */
#define DC_XLEN		60	/* manual syas add 60 to len... */
#define	DC_RRES		0000370	/* Recv: v}or reserved */
#define DC_FRAM		0000004	/* Recv: fram alignment */
#define DC_CERR		0000002	/* Recv: CRC error */
#define DC_OVER		0000001 /* Recv: overflow error */

/* Definitions of device setup packet (see manual ofr details) */

#define DQ_ROWS		16	/* setup has 16 rows */
#define DQ_COLS		8	/* setp has 8 columns */
#define DQ_SETD		8	/* displacment of 2nd copy */
#define DQ_BCST		0377	/* broadcast address bytes */

#define dqlen(x)	(-(((x)+1)>>1))	/* buffer len: map byte length to 2s compl. of word length */

