/* ether.h */

/* 
$Log: ETHER.H,v $
Revision 4.0  2000/02/07 21:52:34  Administrator
rev 4.0

Revision 1.1.1.1  2000/01/23 21:03:28  Administrator
This is the initial release to be CVS'ed

 * Revision 2.0  91/11/30  18:56:32  ROOT_DOS
 * This now contains the conditional compile code to support MTOS on the
 * 68K. This divides the net into three tasks, one does the output, the next
 * the input from a serial port driver and the last is the interface to the
 * calling tasks. The code will also compile into the PC based system with
 * the #define MICROC included and it will run on the PC using port 1.
 *  
*/

/* Ethernet definitions and constants */

#define EMINPAK	64	/* minimum packet length */
#define EMAXPAK	1266	/* 1536; cut here to conserve space */
#define EHLEN	14	/* size of Ethernet packet header */
#define EDLEN	EMAXPAK - EHLEN	/* length of data field in either packet */
#define EPADLEN	6	/* number of octets in physical address */
typedef	char	Eaddr[EPADLEN];	/* length of physical address [48 bits] */
#define EXRETRY	3	/* number of times to retry xmit errors */
#define EBCAST	"\377\377\377\377\377\377"	/* Ethernet broadcast address */

struct eheader
{
	/* format of header in Ethernet packet */
	Eaddr	e_dest;	/* destination host address */
	Eaddr	e_src;	/* source host address */
	short	e_ptype;	/* Ethernet packet type (see below) */
};

#define EP_LOOP	0x0060	/* packet type: loopback */
#define EP_ECHO	0x0200	/* packet type: echo */
#define EP_PUP	0x0400	/* packet type: xerox PUP protocol */
#define EP_IP	0x0800	/* packet type: DARPA Internet protocol */
#define EP_ARP	0x0806	/* packet type: address resolution protocol */
#define EP_RARP	0x8035	/* packet type: reverse resolution protocol */

struct epacket
{
	/* complete structure of Ethernet packet */
	struct eheader ep_hdr;	/* packet data */
	char ep_data[EDLEN];	/* data in the packet */
};

/* Ethernet control block descriptions */

struct etblk
{
	struct dqregs *eioaddr;	/* address of device csr */
	Eaddr etpaddr;	/* ethernet physical device address */
	int etrpid;	/* id of process reading from ethernet */
	int etwpid;	/* id of process writing to ethernet */
	int etrsem;	/* mutex for reading from the ethernet */
	int etwsem;	/* mutex for writing to the ethernet */
	int etsetup;	/* DC_NORM or DC_SETUP for normal/setup */
	int etwtry;	/* num. of times to retry xmit errors */
	struct dcmd ercmd[2];	/* deqna read command descriptor plus } of list */
	struct dcmd ewcmd[2];	/* deqna write command descriptor plus }-of-list */
};


typedef struct
{
	int type;		/* what type of interface is this */
	unsigned char ver;		/* version number of interface s/w */
	unsigned char debug;		/* start debug on interface */
	unsigned char vector;		/* interrupts vector to be used */
	unsigned char irq_level;	/* interrupt level to be used */
	unsigned char if_addr[6];	/* h/w ethernet address */
	unsigned char ip_addr[4];	/* system address */
	int tx_len;		/* length of tx message */
	unsigned char tx_buffer[2048];	/* tx buffer space */
	int rx_len;		/* length of rx message */
	unsigned char rx_buffer[2048];	/* rx buffer space */
}ETH_DEV;

#define Neth	10
extern struct etblk eth[Neth];
extern ETH_DEV *eth_dev;

