/* icmp.h */

/* 
$Log: ICMP.H,v $
Revision 4.0  2000/02/07 21:52:38  Administrator
rev 4.0

Revision 1.1.1.1  2000/01/23 21:03:29  Administrator
This is the initial release to be CVS'ed

 * Revision 2.0  91/11/30  18:56:43  ROOT_DOS
 * This now contains the conditional compile code to support MTOS on the
 * 68K. This divides the net into three tasks, one does the output, the next
 * the input from a serial port driver and the last is the interface to the
 * calling tasks. The code will also compile into the PC based system with
 * the #define MICROC included and it will run on the PC using port 1.
 *  
*/

/* Internet Control Message Protocol constants and packet format */

#define ICRPECH	0	/* echo reply */
#define ICDESTU 3	/* destination unreachable */
#define ICSRCQN 4	/* source quench */
#define ICREDIR 5	/* redirect message type */
#define ICRQECH 8	/* echo request */
#define ICTIMEX 11	/* time exceeded */
#define ICPARMP 12	/* parameter problem */
#define ICTIMST 13	/* timestamp message */
#define ICTIMRP 14	/* time stamp reply */
#define ICRQINF 15	/* information request */
#define ICRPINF 16	/* information reply */

/* ICMP packet format (part of the packet that follows the IP header) */

struct icmp
{
	/* ICMP packet */
	char	ic_typ;		/* type of message (see above) */
	char	ic_code;	/* code (often zero) */
	short	ic_cksum;	/* checksum of icmp header+data */
	short	ic_id;		/* for echo type, a message id */
	short	ic_seq;		/* for echo type, a seq number */
	char	ic_data[1];	/* data area of ICMP message */
};

