/* ip.h */

/*
$Log: IP.H,v $
Revision 4.0  2000/02/07 21:52:39  Administrator
rev 4.0

Revision 1.1.1.1  2000/01/23 21:03:29  Administrator
This is the initial release to be CVS'ed

 * Revision 2.0  91/11/30  18:56:47  ROOT_DOS
 * This now contains the conditional compile code to support MTOS on the
 * 68K. This divides the net into three tasks, one does the output, the next
 * the input from a serial port driver and the last is the interface to the
 * calling tasks. The code will also compile into the PC based system with
 * the #define MICROC included and it will run on the PC using port 1.
 *
*/

/* DARPA internet protocol (IP) Constant and datagram format */

#define IPLEN	4	/* IP address length in bytes (octets) */
typedef unsigned char	IPaddr[IPLEN];	/* DARPA internet address */
#define IPTMASK	0300	/* Mask for IP type in top byte of addr */
#define IPATYP	0000	/* IP Class A address (1st 2 bits) */
#define IPBTYP	0200	/* IP Class B address (1st 2 bits) */
#define IPCTYP	0300	/* IP Class C address (1st 2 bits) */
#define IPHLEN	20	/* IP datagram header length in bytes */
#define IMAXLEN	1200	/* Maximum IP datagram length (Notes : */
			/* 1) hosts & gateways only required */
			/* to recognise 576 bytes. 2) must be */
			/* less than EMXAXPAK for our network */

#define IP_CLASSA(x)	((x[0] & 0x80) == 0x00)	/* IP calss A address */
#define IP_CLASSB(x)	((x[0] & 0xc0) == 0x80)	/* IP calss A address */
#define IP_CLASSC(x)	((x[0] & 0xd0) == 0xc0)	/* IP calss A address */
#define IP_CLASSD(x)	((x[0] & 0xf0) == 0xd0)	/* IP calss A address */
#define IP_CLASSE(x)	((x[0] & 0xf0) == 0xf0)	/* IP calss A address */

/* Assigned Protocol numbers */

#define IPRO_ICMP	1	/* protocol type for ICMP packets */
#define IPRO_TCP	6	/* protocol type for TCP packets */
#define IPRO_UDP	17	/* protocol type for UDP packets */

struct ip
{
	/* format of DARPA Internet datagram */
	char	i_verlen;	/* IP vers (0x40) + hdr len in longs (5) */
	char	i_svctyp;	/* service type (0 => normal service) */
	short	i_paclen;	/* packet length in octets (bytes) */
	short	i_id;		/* datagram id (to help gateways frag.) */
	short	i_fragoff;	/* fragment offset (0 for 1st fragment) */
	char	i_tim2liv;	/* time to live in gateway hops (10) */
	char	i_proto;	/* IP protocol (UDP is assigned 17) */
	short	i_cksum;	/* 1s comple. of sum of shorts in header */
	IPaddr	i_src;		/* IP address of source */
	IPaddr	i_dest;		/* IP address of destination */
	char	i_data[1];	/* IP datagram data area */
};

/* datagram field constants used by simple IP software */
#define IVERLEN	0x45	/* current version length field value */
#define ISVCTYP	'\0'	/* service type for normal service */
#define IFRAGOFF 0	/* fragment offset (0 => no fragment) */
#define ITIM2LIV 10	/* initial time-to-live value */

extern int ipackid;	/* Internet datagram id */

